import org.w3c.dom.*;
import javax.xml.parsers.*;
import javax.xml.transform.*;
import javax.xml.transform.dom.*;
import javax.xml.transform.stream.*;
import java.io.*;

public class DOMRW
{
  public void save(Document doc, String fileName)
  {
    try
    {
      DOMSource source = new DOMSource(doc);
      // file outputStream e' semplicemente il "file", mentre StreamResult
      // e' di DOM
      StreamResult result = new StreamResult(new
                                             FileOutputStream(fileName));
      // eventuali regole di traduzione parametro del traduttore
      Transformer t = TransformerFactory.newInstance().newTransformer();
      t.setOutputProperty(OutputKeys.DOCTYPE_SYSTEM,"solarsystem.dtd");
      t.transform(source, result);
    }
    catch (Exception ex)
    {
      ex.printStackTrace();
    }
  }

  public Document load(String fileName)
  {
    try
    {
      DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
      factory.setValidating(true);
      DocumentBuilder builder = factory.newDocumentBuilder();
      return builder.parse(new File(fileName));
    }
    catch (Exception ex)
    {
      ex.printStackTrace();
      return null;
    }
  }



}
